#ifndef TYPE_VALUE_H_INCLUDED
#define TYPE_VALUE_H_INCLUDED

#define TYPE_VALUE_LONG 1
#define TYPE_VALUE_DOUBLE 2
#define TYPE_VALUE_STRING 3
#define TYPE_VALUE_VOID 4
#define TYPE_VALUE_ULONG 5

struct type_value
{
  unsigned char type;
  union {
    long longval;
    unsigned long ulongval;
    double doubleval;
  } val;
  string stringval;

  type_value() {}
  type_value(const type_value&);
  type_value& operator=(type_value);
};

type_value operator-(type_value&);
type_value operator!(type_value&);
type_value operator~(type_value&);
type_value operator*(type_value&,type_value&);
type_value operator/(type_value&,type_value&);
type_value operator%(type_value&,type_value&);
type_value operator+(type_value&,type_value&);
type_value operator-(type_value&,type_value&);
type_value operator<<(type_value&,type_value&);
type_value operator>>(type_value&,type_value&);
type_value operator<(type_value&,type_value&);
type_value operator>(type_value&,type_value&);
type_value operator<=(type_value&,type_value&);
type_value operator>=(type_value&,type_value&);
type_value operator==(type_value&,type_value&);
type_value operator!=(type_value&,type_value&);
type_value operator&(type_value&,type_value&);
type_value operator^(type_value&,type_value&);
type_value operator|(type_value&,type_value&);
type_value operator&&(type_value&,type_value&);
type_value operator||(type_value&,type_value&);

#endif
